/* 
Lab 1 - File and streams
Last modification : 2020-09-04
*/

#include <iostream>
#include <fstream>
#include <string>

using namespace std;

/*TODO:
1-1 --> done
5-5 --> done

Try to avoid comments on the same line as code
--> done
*/

int main() {
    ifstream myFile("./data.txt");

    // If the file has been correctly opened
    if (myFile) { 
       
        // variable declaration 
        string word{};
        string longest_word{};
        string shortest_word{};
        int word_count{};
        int lw_size{};
        int sw_size{100};
        int length_sum{};
        double aver_length{};

        /*
        In this while loop, we will go through the whole file in order to draw statistics.
        We count each word, each character (to get the average word length at the end of the algorithm)
        and for each word we check if it is the longest or the shortest word encountered so far.
        */
        while (myFile >> word){
            // We count the number of words.
            word_count++;
            // We count the number of characters (only word characters).
            length_sum += word.length();

            // We check if the actual word is the longest met so far.
            if ((int)word.length() > lw_size) {
                longest_word = word;
                lw_size = word.length();
            }
            // We check if the actual word is the shortest met so far.
            else if ((int)word.length() < sw_size) {
                shortest_word = word;
                sw_size = word.length();
            }
        }

        // If our file is NOT empty
        if (word_count > 0) {
            // We calculate the average length of a word with the formula: 
            // total number of characters / number of words
            aver_length = static_cast <double> (length_sum) / static_cast <double> (word_count);

            cout << "There are " << word_count << " words in the file." << endl;
            cout << "The shortest word was \"" << shortest_word << "\" with " << sw_size << " character(s)." << endl;
            cout << "The longest word was \"" << longest_word << "\" with " << lw_size << " character(s)." << endl;
            cout << "The average length was " << aver_length << " character(s)." << endl;
        }
        else {
            cerr << "ERROR : Empty file." << endl;
        }
    }
    else {cerr << "ERROR: Could not open file for reading.";}

    return 0;
}
