#ifndef TIME_H
#define TIME_H
#include <string>
#include <iostream>
#include <iomanip>

/***************** Comment *****************/
/* Nice looking header file, well done!*/
/*******************************************/

/* 
Lab 2 - TDDE18 - Time lab
Last modification : 2020-09-16
*/


/// Structure time 
struct Time
{
    int hours{};
    int minutes{};
    int secondes{}; 
};

/*************** Complementary work ***************/
/* TODO: You must take time as a const reference in order to save
 * performance and in order to promise the user that the given Time
 * object will not be modified. This is true for the thtree following
 * functions*/
//  --> done
/**************************************************/

/// A function which check if a time is valid.
bool is_valid(Time const& t);

/// A function which check a time is after noon.
bool is_am(Time const& t);

/// A function which convert a time to a string. You can specify the time format.
std::string to_string(Time const& t, bool format = false);

/***************** Comment *****************/
/* Well done with the declarations of the +/- operators! */
/*******************************************/

/////////////////
/// Operators ///
/////////////////

/// Time + Time (not asked for lab 2)
Time operator+(Time const& t1, Time const& t2);

/// Time - Time (not asked for lab 2)
Time operator-(Time const& t1, Time const& t2); 

/// Time + integer
Time operator+(Time const& t, int x);

/// Time - integer
Time operator-(Time const& t, int x);

/// Time++
Time& operator++(Time& t);      // prefix
Time operator++(Time& t, int);  // postfix

/// Time--
Time& operator--(Time& t);      // prefix
Time operator--(Time& t, int);  // postfix


/// Time < Time comparison
bool operator<(Time const& t1, Time const& t2);

/// Time > Time comparison
bool operator>(Time const& t1, Time const& t2);

/// Time == Time comparison
bool operator==(Time const& t1, Time const& t2);

/// Time != Time comparison
bool operator!=(Time const& t1, Time const& t2);

/// Time <= Time comparison
bool operator<=(Time const& t1, Time const& t2);

/// Time >= Time comparison
bool operator>=(Time const& t1, Time const& t2);


/// Stream operators overloading <<
std::ostream& operator<<(std::ostream& os, Time const& t);

/// Operator <<
/// The entry must be be in the format HH:SS:MM.
std::istream& operator>>(std::istream& is, Time& t);

#endif
